from .basic_types import Byte, ByteList, Float, FloatList, ShopsType, ShortString, \
                         ShortStringList, SignedLong, String, StringList, Unknown, UnsignedLong

# TODO: Review *List types to custom types

ITEMS_DB_SCHEMA = {
    "name": "Items",
    "file": "items.idb",
    "tables": [
        {
            "id": 1,
            "name": "Materials",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Type", "type": String()},
                {"id": 2, "name": "Code", "type": String()},
                {"id": 3, "name": "ID", "type": SignedLong()},
                {"id": 4, "name": "Price", "type": Float()},
                {"id": 5, "name": "Weight", "type": Float()},
                {"id": 6, "name": "Mana", "type": Float()},
                {"id": 7, "name": "Slots", "type": SignedLong()},
                {"id": 8, "name": "Durability", "type": Float()},
                {"id": 9, "name": "Skill", "type": SignedLong()},
                {"id": 10, "name": "Damage", "type": Float()},
                {"id": 11, "name": "Absorption", "type": "DamageTypes"},
                {"id": 12, "name": "Unk12", "type": SignedLong()},
                {"id": 13, "name": "Shops", "type": ShopsType()},
            ],
        },
        {
            "id": 2,
            "name": "Weapons",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Type", "type": String()},
                {"id": 2, "name": "TypeID", "type": SignedLong()},
                {"id": 3, "name": "Material Type", "type": String()},
                {"id": 4, "name": "Unk4", "type": SignedLong()},
                {"id": 5, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 6, "name": "Texture Type Index 2", "type": SignedLong()},
                {"id": 7, "name": "Price", "type": Float()},
                {"id": 8, "name": "Weight", "type": Float()},
                {"id": 9, "name": "Size", "type": Float()},
                {"id": 10, "name": "Mana", "type": Float()},
                {"id": 11, "name": "Slots", "type": SignedLong()},
                {"id": 12, "name": "Durability", "type": Float()},
                {"id": 13, "name": "Components", "type": SignedLong()},
                {"id": 14, "name": "Shops", "type": ShopsType()},
                {"id": 15, "name": "Deconstructable", "type": Byte()},
                {"id": 21, "name": "Actions", "type": SignedLong()},
                {"id": 22, "name": "Unk22", "type": FloatList()},
                {"id": 23, "name": "Range", "type": Float()},
                {"id": 24, "name": "Damage Min", "type": Float()},
                {"id": 25, "name": "Damage Max", "type": Float()},
                {"id": 26, "name": "Damage Proportions", "type": "DamageTypes"},
                {"id": 27, "name": "Unk27", "type": Unknown()},
                {"id": 28, "name": "Unk28", "type": Unknown()},
                {"id": 29, "name": "Attack modifier", "type": Float()},
                {"id": 30, "name": "Defence modifier", "type": Float()},
            ],
        },
        {
            "id": 3,
            "name": "Armors",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Type", "type": String()},
                {"id": 2, "name": "TypeID", "type": SignedLong()},
                {"id": 3, "name": "Material Type", "type": String()},
                {"id": 4, "name": "Unk4", "type": SignedLong()},
                {"id": 5, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 6, "name": "Texture Type Index 2", "type": SignedLong()},
                {"id": 7, "name": "Price", "type": Float()},
                {"id": 8, "name": "Weight", "type": Float()},
                {"id": 9, "name": "Size", "type": Float()},
                {"id": 10, "name": "Mana", "type": Float()},
                {"id": 11, "name": "Slots", "type": SignedLong()},
                {"id": 12, "name": "Durability", "type": Float()},
                {"id": 13, "name": "Components", "type": SignedLong()},
                {"id": 14, "name": "Shops", "type": ShopsType()},
                {"id": 15, "name": "Deconstructable", "type": Byte()},
                {"id": 21, "name": "Main", "type": "DamageTypes2"},
                {"id": 22, "name": "Additional", "type": "DamageTypes2"},
                {"id": 23, "name": "Graphics Data Apply Wounds", "type": Byte()},
                {"id": 24, "name": "Graphics Data Wear Order", "type": SignedLong()},
                {"id": 25, "name": "Unk25", "type": Unknown()},
                {"id": 26, "name": "Unk26", "type": Unknown()},
            ],
        },
        {
            "id": 4,
            "name": "Quick Items",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Type", "type": String()},
                {"id": 2, "name": "Unk2", "type": SignedLong()},
                {"id": 3, "name": "Material Type", "type": String()},
                {"id": 4, "name": "Unk4", "type": SignedLong()},
                {"id": 5, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 6, "name": "Texture Type Index 2", "type": SignedLong()},
                {"id": 7, "name": "Price", "type": Float()},
                {"id": 8, "name": "Weight", "type": Float()},
                {"id": 9, "name": "Size", "type": Float()},
                {"id": 10, "name": "Mana", "type": Float()},
                {"id": 11, "name": "Slots", "type": SignedLong()},
                {"id": 12, "name": "Durability", "type": Float()},
                {"id": 13, "name": "Components", "type": SignedLong()},
                {"id": 14, "name": "Shops", "type": ShopsType()},
                {"id": 15, "name": "Deconstructable", "type": Byte()},
                {"id": 21, "name": "Quick Item ID", "type": SignedLong()},
                {"id": 22, "name": "Graphics Data Level", "type": SignedLong()},
                {"id": 23, "name": "Damage", "type": Float()},
                {"id": 24, "name": "Unk24", "type": Float()},
                {"id": 25, "name": "Spell", "type": String()},
                {"id": 26, "name": "Modifier", "type": "Modifiers"},
                {"id": 27, "name": "Unk27", "type": Unknown()},
            ],
        },
        {
            "id": 5,
            "name": "Quest Items",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Type", "type": String()},
                {"id": 2, "name": "Unk2", "type": SignedLong()},
                {"id": 3, "name": "Material Type", "type": String()},
                {"id": 4, "name": "Unk4", "type": SignedLong()},
                {"id": 5, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 6, "name": "Texture Type Index 2", "type": SignedLong()},
                {"id": 7, "name": "Price", "type": Float()},
                {"id": 8, "name": "Weight", "type": Float()},
                {"id": 9, "name": "Size", "type": Float()},
                {"id": 10, "name": "Mana", "type": Float()},
                {"id": 11, "name": "Slots", "type": SignedLong()},
                {"id": 12, "name": "Durability", "type": Float()},
                {"id": 13, "name": "Components", "type": SignedLong()},
                {"id": 14, "name": "Shops", "type": ShopsType()},
                {"id": 15, "name": "Deconstructable", "type": Byte()},
                {"id": 21, "name": "ScriptID", "type": SignedLong()},
                {"id": 22, "name": "Zones", "type": StringList()},
            ],
        },
        {
            "id": 6,
            "name": "Loot Items",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Type", "type": String()},
                {"id": 2, "name": "Unk2", "type": SignedLong()},
                {"id": 3, "name": "Material Type", "type": String()},
                {"id": 4, "name": "Unk4", "type": SignedLong()},
                {"id": 5, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 6, "name": "Texture Type Index 2", "type": SignedLong()},
                {"id": 7, "name": "Price", "type": Float()},
                {"id": 8, "name": "Weight", "type": Float()},
                {"id": 9, "name": "Size", "type": Float()},
                {"id": 10, "name": "Mana", "type": Float()},
                {"id": 11, "name": "Slots", "type": SignedLong()},
                {"id": 12, "name": "Durability", "type": Float()},
                {"id": 13, "name": "Components", "type": SignedLong()},
                {"id": 14, "name": "Shops", "type": ShopsType()},
                {"id": 15, "name": "Deconstructable", "type": Byte()},
                {"id": 21, "name": "TypeID", "type": SignedLong()},
                {"id": 22, "name": "Unk22", "type": Unknown()},
                {"id": 23, "name": "Unk23", "type": SignedLong()},
            ],
        },
    ],
    "types": {
        "DamageTypes": {
            "base": FloatList(7),
            "names": [
                "Piercing",
                "Slashing",
                "Bludgeoning",
                "Termal",
                "Chemic",
                "Electric",
                "General",
            ],
        },
        "DamageTypes2": {
            "base": FloatList(9),
            "names": [
                "Absrobtion",
                "Piercing",
                "Slashing",
                "Bludgeoning",
                "Termal",
                "Chemic",
                "Electric",
                "General",
                "Unk",
            ],
        },
        "Modifiers": {
            "base": ByteList(3),
            "names": [
                "Science",
                "Stealing",
                "Unk",
            ],
        },
    },
}

LEVERS_DB_SCHEMA = {
    "name": "Levers",
    "file": "levers.ldb",
    "tables": [
        {
            "id": 1,
            "name": "Lever Prototypes",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Places", "type": "PlaceType"},
                {"id": 2, "name": "PlacesNum", "type": SignedLong()},
                {"id": 3, "name": "Scale", "type": Float()},
                {"id": 4, "name": "Switch Time", "type": SignedLong()},
                {"id": 5, "name": "Material", "type": String()},
                {"id": 6, "name": "Switch Sound", "type": String()},
                {"id": 7, "name": "Lever Text", "type": String()},
            ],
        },
    ],
    "types": {
        "PlaceType": {
            "base": FloatList(4),
            "names": [
                "P1 X",
                "P1 Y",
                "P2 X",
                "P2 Y",
            ],
        },
    },
}

PERKS_DB_SCHEMA = {
    "name": "Perks",
    "file": "perks.pdb",
    "tables": [
        {
            "id": 1,
            "name": "Skills",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Code", "type": String()},
                {"id": 2, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 10, "name": "Base Attributes", "type": StringList()},
            ],
        },
        {
            "id": 2,
            "name": "Perks",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Code", "type": String()},
                {"id": 2, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 10, "name": "Perk", "type": String()},
                {"id": 11, "name": "Skill", "type": String()},
                {"id": 12, "name": "SkillID", "type": SignedLong()},
                {"id": 13, "name": "Unk13", "type": SignedLong()},
                {"id": 14, "name": "Skill Level", "type": SignedLong()},
                {"id": 15, "name": "Strength", "type": Float()},
                {"id": 16, "name": "Dexterity", "type": Float()},
                {"id": 17, "name": "Intelligence", "type": Float()},
                {"id": 18, "name": "Cost", "type": SignedLong()},
                {"id": 19, "name": "Modifier", "type": SignedLong()},
                {"id": 20, "name": "Mult", "type": SignedLong()},
                {"id": 21, "name": "Add", "type": SignedLong()},
                {"id": 22, "name": "Active", "type": Byte()},
                {"id": 23, "name": "Perk Exclusive", "type": SignedLong()},
            ],
        },
    ],
    "types": {},
}

SPELLS_DB_SCHEMA = {
    "name": "Spells",
    "file": "spells.sdb",
    "tables": [
        {
            "id": 1,
            "name": "Spell Prototypes",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Code", "type": String()},
                {"id": 2, "name": "SubType", "type": String()},
                {"id": 3, "name": "Price", "type": Float()},
                {"id": 4, "name": "Type", "type": SignedLong()},
                {"id": 5, "name": "Mana", "type": Float()},
                {"id": 6, "name": "Slots", "type": SignedLong()},
                {"id": 7, "name": "Speed", "type": Float()},
                {"id": 8, "name": "Range", "type": Float()},
                {"id": 9, "name": "Area", "type": Float()},
                {"id": 10, "name": "Effect", "type": Float()},
                {"id": 11, "name": "Target", "type": SignedLong()},
                {"id": 12, "name": "Targets", "type": SignedLong()},
                {"id": 13, "name": "Duration", "type": SignedLong()},
                {"id": 14, "name": "Actions", "type": SignedLong()},
                {"id": 15, "name": "Require Trace", "type": UnsignedLong()},
                {"id": 16, "name": "BuiltIn Mods", "type": ShortStringList()},
                {"id": 17, "name": "Special Mods", "type": ShortStringList()},
                {"id": 18, "name": "Texture Type Index", "type": SignedLong()},
                {"id": 19, "name": "SubTypeCode", "type": SignedLong()},
                {"id": 20, "name": "Available Mods", "type": "SpellMods"},
                {"id": 21, "name": "Complex", "type": SignedLong()},
                {"id": 22, "name": "Shops", "type": ShopsType()},
                {"id": 23, "name": "Light Red", "type": Float()},
                {"id": 24, "name": "Light Green", "type": Float()},
                {"id": 25, "name": "Light Blue", "type": Float()},
                {"id": 26, "name": "Light Raduis", "type": Float()},
                {"id": 27, "name": "Fadeout Time", "type": Float()},
            ],
        },
        {
            "id": 2,
            "name": "Spell Modifiers",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Code", "type": ShortString()},
                {"id": 2, "name": "Price", "type": Float()},
                {"id": 3, "name": "Type", "type": SignedLong()},
                {"id": 4, "name": "Mana", "type": Float()},
                {"id": 5, "name": "Value", "type": Float()},
                {"id": 6, "name": "Complex", "type": SignedLong()},
                {"id": 7, "name": "Allod", "type": String()},
                {"id": 8, "name": "Shops", "type": ShopsType()},
            ],
        },
        {
            "id": 3,
            "name": "Spell Templates",
            "fields": [
                {"id": 1, "name": "Prototype", "type": String()},
                {"id": 2, "name": "Required", "type": StringList()},
                {"id": 3, "name": "Optional", "type": StringList()},
                {"id": 4, "name": "Power", "type": String()},
                {"id": 5, "name": "Shops", "type": ShopsType()},
            ],
        },
        {
            "id": 4,
            "name": "Armor Spell Templates",
            "fields": [
                {"id": 1, "name": "Prototype", "type": String()},
                {"id": 2, "name": "Required", "type": StringList()},
                {"id": 3, "name": "Optional", "type": StringList()},
                {"id": 4, "name": "Power", "type": String()},
                {"id": 5, "name": "Shops", "type": ShopsType()},
            ],
        },
        {
            "id": 5,
            "name": "Weapon Spell Templates",
            "fields": [
                {"id": 1, "name": "Prototype", "type": String()},
                {"id": 2, "name": "Required", "type": StringList()},
                {"id": 3, "name": "Optional", "type": StringList()},
                {"id": 4, "name": "Power", "type": String()},
                {"id": 5, "name": "Shops", "type": ShopsType()},
            ],
        },
    ],
    "types": {
        "SpellMods": {
            "base": ByteList(5),
            "names": [
                "Range",
                "Targets",
                "Area",
                "Effect",
                "Duration",
            ],
        },
    },
}

PRINTS_DB_SCHEMA = {
    "name": "Prints",
    "file": "prints.db",
    "tables": [
        {
            "id": 1,
            "name": "Blood Prints",
            "fields": [
                {"id": 1, "name": "Terrain Type", "type": String()},
                {"id": 2, "name": "Clear Weather", "type": "PrintsParams"},
                {"id": 3, "name": "Weather Precipitation", "type": "PrintsParams"},
            ],
        },
        {
            "id": 2,
            "name": "Foot Prints",
            "fields": [
                {"id": 1, "name": "Terrain Type", "type": String()},
                {"id": 2, "name": "Clear Weather", "type": "PrintsParams"},
                {"id": 3, "name": "Weather Precipitation", "type": "PrintsParams"},
                {"id": 10, "name": "Bloody", "type": "PrintsParams"},
            ],
        },
        {
            "id": 3,
            "name": "Fire Prints",
            "fields": [
                {"id": 1, "name": "Terrain Type", "type": String()},
                {"id": 2, "name": "Clear Weather", "type": "PrintsParams"},
                {"id": 3, "name": "Weather Precipitation", "type": "PrintsParams"},
            ],
        },
    ],
    "types": {
        "PrintsParams": [
            {"id": 1, "name": "Opacity", "type": Float()},
            {"id": 2, "name": "Lifetime", "type": SignedLong()},
            {"id": 3, "name": "Fadeout", "type": SignedLong()},
        ],
    },
}

UNITS_DB_SCHEMA = {
    "name": "Units",
    "file": "units.udb",
    "tables": [
        {
            "id": 1,
            "name": "Hit Locations",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Other General", "type": FloatList()},
                {"id": 2, "name": "Other General2", "type": FloatList()},
                {"id": 3, "name": "Unk3", "type": UnsignedLong()},
                {"id": 4, "name": "Unk4", "type": UnsignedLong()},
            ],
        },
        {
            "id": 2,
            "name": "Race Models",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "TypeId", "type": UnsignedLong()},
                {"id": 2, "name": "Regenerate Health", "type": Float()},
                {"id": 3, "name": "Regenerate Mana", "type": Float()},
                {"id": 4, "name": "Secondary Language", "type": UnsignedLong()},
                {"id": 5, "name": "Secondary Locomotion", "type": UnsignedLong()},
                {"id": 6, "name": "Secondary Vision arc", "type": Float()},
                {"id": 7, "name": "Speed Crawl", "type": FloatList()},
                {"id": 8, "name": "Attack Distance", "type": Float()},
                {"id": 9, "name": "AI Class Stay", "type": UnsignedLong()},
                {"id": 10, "name": "AI Class Lie", "type": UnsignedLong()},
                {"id": 11, "name": "Attack General", "type": FloatList()},
                {"id": 12, "name": "HL Head", "type": "HlParams"},
                {"id": 13, "name": "HL Torso", "type": "HlParams"},
                {"id": 14, "name": "HL Right Arm", "type": "HlParams"},
                {"id": 15, "name": "HL Left Arm", "type": "HlParams"},
                {"id": 16, "name": "HL Right Leg", "type": "HlParams"},
                {"id": 17, "name": "HL Left Leg", "type": "HlParams"},
                {"id": 30, "name": "Graphics Data Mask Name", "type": String()},
                {"id": 31, "name": "Graphics Data Primary textures", "type": StringList()},
                {"id": 32, "name": "Graphics Data Secondary textures", "type": StringList()},
                {"id": 33, "name": "Graphics Data Model Shift", "type": Float()},
                {"id": 34, "name": "Sounds data SFX Path", "type": String()},
                {"id": 35, "name": "Sounds data Steps", "type": StringList()},
                {"id": 36, "name": "Animation Speed Special", "type": FloatList()},
                {"id": 37, "name": "Sounds Probability Idle", "type": UnsignedLong()},
                {"id": 38, "name": "Sounds Probability Attack", "type": UnsignedLong()},
                {"id": 39, "name": "Defence General", "type": FloatList()},
                {"id": 40, "name": "Graphics Data Blood Type", "type": UnsignedLong()},
                {"id": 41, "name": "Graphics Data Cast Type", "type": UnsignedLong()},
                {"id": 42, "name": "Graphics Data Footprint Type", "type": SignedLong()},
                {"id": 43, "name": "Graphics Data Leg Segments", "type": UnsignedLong()},
                {"id": 44, "name": "Graphics Data Skin Type", "type": String()},
                {"id": 45, "name": "Graphics Data First Step Right", "type": Byte()},
                {"id": 46, "name": "Graphics Data Head Height", "type": Float()},
                {"id": 47, "name": "Unk47", "type": UnsignedLong()},
                {"id": 48, "name": "Unk48", "type": UnsignedLong()},
                {"id": 49, "name": "Unk49", "type": UnsignedLong()},
                {"id": 50, "name": "Unk50", "type": UnsignedLong()},
            ],
        },
        {
            "id": 3,
            "name": "Monster Prototypes",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Base Race", "type": String()},
                {"id": 2, "name": "Unk2", "type": SignedLong()},
                {"id": 3, "name": "Graphics Data Skin Index", "type": UnsignedLong()},
                {"id": 4, "name": "Graphics Data Hair", "type": SignedLong()},
                {"id": 5, "name": "Graphics Data Complection X", "type": Float()},
                {"id": 6, "name": "Graphics Data Complection Y", "type": Float()},
                {"id": 7, "name": "Graphics Data Complection Z", "type": Float()},
                {"id": 8, "name": "Unk8", "type": String()},
                {"id": 9, "name": "Stats Health", "type": Float()},
                {"id": 10, "name": "Stats Mana", "type": Float()},
                {"id": 11, "name": "Stats Absorbtion", "type": Float()},
                {"id": 12, "name": "Tuning Actions", "type": Float()},
                {"id": 13, "name": "Tuning Move", "type": Float()},
                {"id": 14, "name": "Attack Range", "type": Float()},
                {"id": 15, "name": "Stats To Hit", "type": Float()},
                {"id": 16, "name": "Stats Parry", "type": Float()},
                {"id": 17, "name": "Tuning Weapon Weight", "type": Float()},
                {"id": 18, "name": "Attack Weapon Type Id", "type": UnsignedLong()},
                {"id": 19, "name": "Stats Danage Nub", "type": Float()},
                {"id": 20, "name": "Stats Damage Max", "type": Float()},
                {"id": 21, "name": "Skills General", "type": Float()},
                {"id": 22, "name": "Skills Steal", "type": Float()},
                {"id": 23, "name": "Skills Tame", "type": Float()},
                {"id": 24, "name": "Skills Peripheral", "type": Float()},
                {"id": 25, "name": "Senses Tracking", "type": FloatList()},
                {"id": 26, "name": "Detections Tracking", "type": FloatList()},
                {"id": 27, "name": "Common loot", "type": "LootParams"},
                {"id": 28, "name": "Rare loot", "type": "LootParams"},
                {"id": 29, "name": "Items", "type": StringList()},
                {"id": 30, "name": "Skills Astral", "type": FloatList()},
                {"id": 31, "name": "Spells", "type": StringList()},
                {"id": 32, "name": "Equipment Wears", "type": StringList()},
                {"id": 33, "name": "Equipment Weapon 1", "type": String()},
                {"id": 34, "name": "Graphics Data Info Window Scale", "type": Float()},
                {"id": 35, "name": "Graphics Data Altitude", "type": Float()},
                {"id": 36, "name": "Tuning To hit Random", "type": Float()},
                {"id": 37, "name": "Graphics Data Dialog Camera Distance", "type": Float()},
                {"id": 38, "name": "Graphics Data Dialog Camera Height", "type": Float()},
                {"id": 39, "name": "Attack Real Weapon Type Id", "type": UnsignedLong()},
                {"id": 40, "name": "Graphics Data Detonation", "type": Float()},
                {"id": 41, "name": "Base Level", "type": UnsignedLong()},
                {"id": 42, "name": "Equipment Weapon 2", "type": String()},
                {"id": 43, "name": "Stats Exp", "type": Float()},
            ],
        },
        {
            "id": 4,
            "name": "NPCs",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Unk1", "type": UnsignedLong()},
                {"id": 2, "name": "Exp", "type": Float()},
                {"id": 3, "name": "Strength", "type": Float()},
                {"id": 4, "name": "Dexterity", "type": Float()},
                {"id": 5, "name": "Intelligence", "type": Float()},
                {"id": 6, "name": "Tame", "type": ByteList()},
                {"id": 7, "name": "Awareness", "type": ByteList()},
                {"id": 8, "name": "Perks", "type": StringList()},
                {"id": 9, "name": "Weapons", "type": StringList()},
                {"id": 10, "name": "Quest Items", "type": StringList()},
                {"id": 11, "name": "Spells", "type": StringList()},
                {"id": 12, "name": "Exp To Distribute", "type": Float()},
                {"id": 13, "name": "Money", "type": UnsignedLong()},
                {"id": 14, "name": "Using Voice", "type": Byte()},
            ],
        },
    ],
    "types": {
        "HlParams": [
            {"id": 0, "name": "Type", "type": String()},
            {"id": 1, "name": "Unk", "type": UnsignedLong()},
            {"id": 2, "name": "Weight", "type": Float()},
            {"id": 3, "name": "Vitality", "type": Float()},
        ],
        "LootParams": [
            {"id": 0, "name": "Probability", "type": Float()},
            {"id": 1, "name": "Mask", "type": Float()},
            {"id": 2, "name": "Min", "type": Float()},
            {"id": 3, "name": "Max", "type": Float()},
        ],
    },
}

QUESTS_DB_SCHEMA = {
    "name": "Quests",
    "file": "quests.qdb",
    "tables": [
        {
            "id": 1,
            "name": "Quests",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Experience", "type": Float()},
                {"id": 2, "name": "Unk2", "type": SignedLong()},
                {"id": 3, "name": "Zone Number", "type": SignedLong()},
                {"id": 4, "name": "Comment", "type": String()},
                {"id": 5, "name": "Money", "type": SignedLong()},
                {"id": 6, "name": "Record Number", "type": SignedLong()},
                {"id": 7, "name": "Unk7", "type": StringList()},
            ],
        },
        {
            "id": 2,
            "name": "Briefings",
            "fields": [
                {"id": 0, "name": "Name", "type": String()},
                {"id": 1, "name": "Unk1", "type": Float()},
                {"id": 2, "name": "Money", "type": Float()},
                {"id": 3, "name": "Give Items", "type": StringList()},
                {"id": 4, "name": "Comment", "type": String()},
                {"id": 5, "name": "Take Items", "type": StringList()},
                {"id": 6, "name": "Give Quests 1", "type": StringList()},
                {"id": 7, "name": "Give Quests 2", "type": StringList()},
                {"id": 8, "name": "Open Zones", "type": StringList()},
                {"id": 9, "name": "Unk9", "type": StringList()},
                {"id": 10, "name": "Bonus Number", "type": SignedLong()},
            ],
        },
    ],
    "types": {},
}

ACKS_DB_SCHEMA = {
    "name": "Acks",
    "file": "acks.db",
    "tables": [
        {
            "id": 1,
            "name": "Answers",
            "fields": [
                {"id": 1, "name": "Name", "type": String()},
                {"id": 10, "name": "Select", "type": "List(AcksUniqueType1)"},
                {"id": 11, "name": "Move", "type": "List(AcksUniqueType1)"},
                {"id": 12, "name": "Attack", "type": "List(AcksUniqueType1)"},
                {"id": 13, "name": "Cast", "type": "List(AcksUniqueType1)"},
                {"id": 14, "name": "Loot", "type": "List(AcksUniqueType1)"},
                {"id": 15, "name": "UseObj", "type": "List(AcksUniqueType1)"},
                {"id": 16, "name": "Steal", "type": "List(AcksUniqueType1)"},
                {"id": 17, "name": "Follow", "type": "List(AcksUniqueType1)"},
                {"id": 18, "name": "UsePot", "type": "List(AcksUniqueType1)"},
                {"id": 19, "name": "ChPos", "type": "List(AcksUniqueType1)"},
                {"id": 20, "name": "NoWay", "type": "List(AcksUniqueType1)"},
                {"id": 21, "name": "CntChPos", "type": "List(AcksUniqueType1)"},
                {"id": 22, "name": "NoPath", "type": "List(AcksUniqueType1)"},
                {"id": 23, "name": "CantCast", "type": "List(AcksUniqueType1)"},
                {"id": 24, "name": "CantTele", "type": "List(AcksUniqueType1)"},
                {"id": 25, "name": "SkiFail", "type": "List(AcksUniqueType1)"},
                {"id": 26, "name": "NoTarget", "type": "List(AcksUniqueType1)"},
                {"id": 27, "name": "ComplSp", "type": "List(AcksUniqueType1)"},
                {"id": 28, "name": "DecToAtt", "type": "List(AcksUniqueType1)"},
                {"id": 29, "name": "OutStam", "type": "List(AcksUniqueType1)"},
                {"id": 30, "name": "ArmCrip", "type": "List(AcksUniqueType1)"},
                {"id": 31, "name": "LegCrip", "type": "List(AcksUniqueType1)"},
                {"id": 32, "name": "Bored", "type": "List(AcksUniqueType2)"},
                {"id": 33, "name": "Unknown", "type": "List(AcksUniqueType1)"},
                {"id": 34, "name": "Overload", "type": "List(AcksUniqueType1)"},
                {"id": 35, "name": "Injured", "type": "List(AcksUniqueType1)"},
                {"id": 36, "name": "BigAtt", "type": "List(AcksUniqueType1)"},
                {"id": 37, "name": "ArmorCrip", "type": "List(AcksUniqueType1)"},
                {"id": 38, "name": "WearCrip", "type": "List(AcksUniqueType1)"},
                {"id": 39, "name": "AttInDef", "type": "List(AcksUniqueType1)"},
                {"id": 40, "name": "WaitFoll", "type": "List(AcksUniqueType1)"},
                {"id": 41, "name": "Scenario", "type": "List(AcksUniqueType1)"},
                {"id": 42, "name": "StealEmp", "type": "List(AcksUniqueType1)"},
                {"id": 43, "name": "ShopYes", "type": "List(AcksUniqueType1)"},
                {"id": 44, "name": "ShopNo", "type": "List(AcksUniqueType1)"},
            ],
        },
        {
            "id": 2,
            "name": "Cryes",
            "fields": [
                {"id": 1, "name": "Name", "type": String()},
                {"id": 10, "name": "Agress", "type": "List(AcksUniqueType1)"},
                {"id": 11, "name": "Suspect", "type": "List(AcksUniqueType1)"},
                {"id": 12, "name": "Kill", "type": "List(AcksUniqueType1)"},
                {"id": 13, "name": "Rest", "type": "List(AcksUniqueType1)"},
                {"id": 14, "name": "InAgress", "type": "List(AcksUniqueType1)"},
            ],
        },
        {
            "id": 3,
            "name": "Others",
            "fields": [
                {"id": 1, "name": "Name", "type": String()},
                {"id": 10, "name": "Talk", "type": "List(AcksUniqueType1)"},
                {"id": 11, "name": "Rest", "type": "List(AcksUniqueType1)"},
            ],
        },
    ],
    "types": {
        "AcksUniqueType1": [
            {"id": 1, "name": "Path", "type": String()},
            {"id": 2, "name": "Unk2", "type": SignedLong()},
            {"id": 3, "name": "Translate", "type": String()},
            {"id": 4, "name": "Code", "type": String()},
        ],
        "AcksUniqueType2": [
            {"id": 1, "name": "Path", "type": String()},
            {"id": 2, "name": "Unk2", "type": SignedLong()},
            {"id": 3, "name": "Translate", "type": String()},
            {"id": 4, "name": "Code", "type": String()},
            {"id": 10, "name": "Unk10", "type": UnsignedLong()},
        ],
    },
}

SCHEMAS_LIST = [
    ITEMS_DB_SCHEMA,
    LEVERS_DB_SCHEMA,
    PERKS_DB_SCHEMA,
    SPELLS_DB_SCHEMA,
    PRINTS_DB_SCHEMA,
    UNITS_DB_SCHEMA,
    QUESTS_DB_SCHEMA,
    ACKS_DB_SCHEMA,
]
